package sample.aop;

import org.jboss.aop.*;
import sample.dao.CounterDAOFactory;
import sample.dao.DAOException;
import sample.dao.CounterDAO;
import sample.dao.CounterNotFoundException;
import sample.pojo.Counter;

/** JE^p̉iC^Zv^ **/
public class PersistenceInterceptor implements Interceptor {
  private static CounterDAO dao = CounterDAOFactory.getInstance();

  public String getName() {
    return "PersistenceInterceptor";
  }

  public InvocationResponse invoke(Invocation invocation) throws Throwable {
    // \bh̃C^[Zvg
    if (invocation.getType() == InvocationType.METHOD) {
      MethodInvocation mi = (MethodInvocation) invocation;

      // \bh"getNextValue"̏ꍇ
      if (mi.method.getName().equals("getNextValue")) {
        Counter counter = (Counter) mi.targetObject;

        load(counter); // JE^IuWFNg̃f[^DB烍[h
        InvocationResponse rsp = invocation.invokeNext(); // ̃C^[Zv^Ăяo
        store(counter); // JE^IuWFNg̃f[^DBփXgA

        return rsp;
      }
    }
    // \bhȊÕC^[Zvg
    return invocation.invokeNext();
  }

  private Counter findOrCreate(Counter counter)throws DAOException {
    try {
      return dao.find(counter.getName());
    } catch(CounterNotFoundException e) {
      dao.create(counter);
      return counter;
    }
  }

  private void load(Counter counter) throws DAOException {
    System.out.println("[h: " + counter);
    Counter found = findOrCreate(counter);
    counter.update(found);
  }

  private void store(Counter counter) throws DAOException {
    System.out.println("XgA: " + counter);
    dao.update(counter);
  }
}
