package sample.aop;

import org.jboss.aop.*;

public class ProfileInterceptor implements Interceptor {
  public String getName() {
    return "ProfileInterceptor";
  }

  public InvocationResponse invoke(Invocation invocation) throws Throwable {
    if (invocation.getType() == InvocationType.METHOD) {
      String profile = (String) invocation.getMetaData("sample", "prof-attribute");

      if ((profile != null) && (profile.equalsIgnoreCase("true"))) {
        MethodInvocation mi = (MethodInvocation) invocation;
        String methodName = mi.method.getName();

        System.out.println(">>>Jn");
        long start = System.currentTimeMillis();
        InvocationResponse rsp = invocation.invokeNext();
        long end = System.currentTimeMillis();
        System.out.println(">>>oߎ:" + methodName + "=>" + (end - start) + "(ms)");
        return rsp;
      }
    }
    return invocation.invokeNext();
  }
}
