package sample.aop;

import org.jboss.aop.*;
import javax.naming.*;
import javax.transaction.*;

/** EJBCNȃgUNVǗsC^Zv^ **/
public class TransactionInterceptor implements Interceptor {
  private static TransactionManager transactionManager;

  private void initManager() throws Throwable {
    try {
      InitialContext initialContext = new InitialContext();
      transactionManager = (TransactionManager) initialContext.lookup("java:/TransactionManager");
    } catch (NamingException e) {
      e.printStackTrace();
      throw e;
    }
  }

  public TransactionManager getTxManager() throws Throwable {
    if (transactionManager == null) initManager();
    return transactionManager;
  }

  public String getName() {
    return "TransactionInterceptor";
  }

  public InvocationResponse invoke(Invocation invocation) throws Throwable {

    InvocationResponse rsp = null;

    // \bh̃C^[Zvg
    if (invocation.getType() == InvocationType.METHOD) {
      MethodInvocation mi = (MethodInvocation) invocation;
      // ^f[^̎擾
      String tranAttribute = (String) invocation.getMetaData("sample", "trans-attribute");

      if ((tranAttribute != null) && (tranAttribute.length() > 0)) {
        TransactionManager tm = getTxManager(); // JgEgUNV̎擾
        Transaction tx = tm.getTransaction();

        boolean isRequired = tranAttribute.equalsIgnoreCase("Required");

        // gUNV"Required"̏ꍇ
        if (isRequired) {
          if (tx == null) {
            System.out.println("gUNV: begin");
            tm.begin();
          }
          try {
            rsp = invocation.invokeNext(); // ̃C^Zv^Ăяo

            if (tx == null) {
              if (isRequired) {
                System.out.println("gUNV: commit");
                tm.commit();
              }
            }
          } catch (Exception e) {
            System.out.println("gUNV: rollback");
            tm.rollback();
            throw e;
          }
          return rsp;
        }
        else {
        // gUNV"Required"ȊȌꍇ
        }
      }
    }
    // \bhȊÕC^[Zvg
    return invocation.invokeNext();
  }
}