package sample.pojo;

/**
 *
 * @jboss-aop.interceptor-pointcut class="sample.aop.ProfileInterceptor"
 * @jboss-aop.interceptor-pointcut class="sample.aop.TransactionInterceptor"
 * @jboss-aop.interceptor-pointcut class="sample.aop.LockInterceptor"
 * @jboss-aop.interceptor-pointcut class="sample.aop.PersistenceInterceptor"
 *
 * @jboss-aop.metadata group="sample" trans-attribute="Supports"
 */
public class CounterImpl implements Counter {
  String name;
  long value;

  public CounterImpl() {
  }

  public CounterImpl(String name, long value) {
    this.name = name;
    this.value = value;
  }

  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public long getValue() {
    return value;
  }

  public void setValue(long value) {
    this.value = value;
  }

  /**
   * @jboss-aop.metadata group="sample" prof-attribute="true"
   * @jboss-aop.metadata group="sample" trans-attribute="Required"
   */
  public long getNextValue() {
    value = value + 1;
    return value;
  }

  public void update(Counter updated) {
    this.value = updated.getValue();
  }

  public String toString() {
    return "{name=" + name + ", value=" + value + "}";
  }

}